using System;

namespace Sante
{
    internal class Program
    {

        static void Main(string[] args)
        {   //0=nema prolaz/ista santa 2=pun leda 1=nema leda
            string[] NM = Console.ReadLine().Split();
            int N = int.Parse(NM[0]);
            int M = int.Parse(NM[1]);
            int[,] prolazi = new int[N, N];
            for (int i = 0; i < M; i++)
            {
                string[] prolaz = Console.ReadLine().Split();
                int santaA = int.Parse(prolaz[0]);
                int santaB = int.Parse(prolaz[1]);
                prolazi[santaA - 1, santaB - 1] = int.Parse(prolaz[2]) + 1;
            }
            string[] MikaLaza = Console.ReadLine().Split();
            int mika = int.Parse(MikaLaza[0]) - 1;
            int laza = int.Parse(MikaLaza[1]) - 1;
            int brojac = 0;
            bool ukljucen = false;
            int j = 1;
            while (mika != laza && j != N)
            {
                brojac = 0;
                mika = int.Parse(MikaLaza[0]) - 1;
                ukljucen = false;
                for (int i = j; i < N; i++)
                {

                    if (prolazi[mika, i] == 0) continue;
                    else if (prolazi[mika, i] == 1 && ukljucen)
                    {
                        mika = i;
                        brojac++;
                        ukljucen = !ukljucen;
                    }
                    else if (prolazi[mika, i] == 2 && ukljucen)
                    {
                        mika = i;
                    }
                    else if (prolazi[mika, i] == 1 && !ukljucen)
                    {
                        mika = i;
                    }
                    else if (prolazi[mika, i] == 2 && !ukljucen)
                    {
                        mika = i;
                        brojac++;
                        ukljucen = !ukljucen;
                    }
                }
                j++;

            }
            if (mika == laza)
            {
                Console.Write(brojac);
            }
            else
            {
                Console.Write("-1");
            }
        }
    }
}